; ##############################################################################
; ##############################################################################
; ##############################################################################
STARTWERTE:
	; NULL				
	clr NULL
	; EINS				
	ldi temp,1
	mov EINS,temp
	; VOLL				
	ldi temp,255
	mov VOLL,temp
	; SRAM CHECK		
	ldi temp,'S'
	STS(adr_SRAM_CHECK),temp
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
WDR_INITIALISIERUNG:
	ldi TEMP,(1<<WDCE)|(1<<WDE) ; Watchdog aktivieren (max. Zeit)				
	out wdtcr,TEMP       
	ldi TEMP,(1<<WDE) | (1<<WDP2)|(1<<WDP1)|(1<<WDP0) 
	out wdtcr,temp
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
SRAM_CLEAR:
	ldi ZL, LOW (SRAM_START)
	ldi ZH, HIGH(SRAM_START)
	ldi temp,0
;-------------------------------------------------------------------------------
SRAM_CLEAR_w:
	ST z+,temp
	cpi ZH, HIGH(RAMEND-1)	; Vergleich?		
	brlo SRAM_CLEAR_w		; kleiner => SPRUNG	
	cpi ZL, LOW(RAMEND-1)	; Vergleich?		
	brlo SRAM_CLEAR_w		; kleiner => SPRUNG	
	breq SRAM_CLEAR_w		; gleich  => SPRUNG	
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
PORT_INI:
	clr temp
	out DDRB, temp
	out DDRC, temp
	out DDRD, temp
	out PORTB,temp				
	out PORTC,temp				
	out PORTD,temp	
	; auf AUSGANG								
	sbi (GRUEN_DDR),(GRUEN_PIN_NR)		; GRN	
	sbi (GELB_DDR) ,(GELB_PIN_NR)		; GELB	
	sbi (ROT_DDR)  ,(ROT_PIN_NR)		; ROT	
;-------------------------------------------------------------------------------
	GRUEN_OFF
	GELB_OFF
	ROT_OFF
;-------------------------------------------------------------------------------
	ROT_ON
	rcall wait_100ms
	GELB_ON
	rcall wait_100ms
	GRUEN_ON

	rcall wait_1s
	ROT_OFF
	GELB_OFF
	GRUEN_OFF
	rjmp wait_1s
; ##############################################################################
; ##############################################################################
; ##############################################################################
PROGRAMM_CHECK:
	; NULL		
	tst NULL
	brne PROGRAMM_CHECK_ERROR
	; EINS		
	mov temp,EINS
	cpi temp,1
	brne PROGRAMM_CHECK_ERROR
	; VOLL		
	mov temp,VOLL
	cpi temp,255
	brne PROGRAMM_CHECK_ERROR
	; SRAM CHECK
	LDS temp,(adr_SRAM_CHECK)
	cpi temp,'S'
	brne PROGRAMM_CHECK_ERROR
	ret
;-------------------------------------------------------------------------------
PROGRAMM_CHECK_ERROR:
	CLI 										; Global Interrupt Disable
	rcall wait_100ms
	ROT_ON
	rcall wait_100ms
	GRUEN_OFF
	GELB_OFF
	ROT_OFF
	rjmp PROGRAMM_CHECK_ERROR
; ##############################################################################
; ##############################################################################
; ##############################################################################
PROGRAMM_STOP:
	WDR
	GELB_ON
	rcall WAIT_50ms
	GELB_OFF
	rcall WAIT_50ms
	rjmp PROGRAMM_STOP
; ##############################################################################
; ##############################################################################
; ##############################################################################
