; ##############################################################################
; ##############################################################################
; ##############################################################################
LCD_TWI_TEST:
	ldi temp1,(TWI_ADRESS_LCD)			; adresse	
	rcall TWI_MT_START_TEMP1			; TWI-START	
	ldi temp1,(1<<LCD_RS)|(0<<LCD_RW)|(1<<LCD_EN)|(0<<LCD_LED)|(1<<LCD_D4)|(1<<LCD_D5)|(1<<LCD_D6)|(1<<LCD_D7)	; Data        				
	rcall TWI_MT_DATA_TEMP1																						; TWI TX-Data (Light off)	
	rcall WAIT_20ms																											
	ldi temp1,(1<<LCD_RS)|(0<<LCD_RW)|(1<<LCD_EN)|(1<<LCD_LED)|(1<<LCD_D4)|(1<<LCD_D5)|(1<<LCD_D6)|(1<<LCD_D7)	; Data        				
	rcall TWI_MT_DATA_TEMP1	


	rcall TWI_STOP						; TWI-STOP	
	tst ERROR							; Error ?	
	brne LCD_TWI_TEST_ERROR
	ret
;-------------------------------------------------------------------------------
; ERROR TWI-Adresse																
LCD_TWI_TEST_ERROR:
	GRUEN_OFF
	GELB_ON
	ROT_ON
	rcall WAIT_100ms
	GELB_OFF
	ROT_OFF
	rcall WAIT_100ms
	rjmp LCD_TWI_TEST_ERROR
;###############################################################################
;###############################################################################
;###############################################################################
;Bit 7  6  5  4  3   2  1  0													
;	D7-D6-D5-D4-LED-EN-RW-RS													
LCD_INI:
	ldi temp, 0b00000011        ;muss 3mal hintereinander gesendet werden		
	rcall LCD_COMMAND_TEMP
	rcall wait_10ms
	ldi temp, 0b00000011
	rcall LCD_COMMAND_TEMP
	rcall wait_10ms
	ldi temp, 0b00000011
	rcall LCD_COMMAND_TEMP
	rcall wait_10ms

	ldi temp, 0b00000010        ;4bit-Modus einstellen							
	rcall LCD_COMMAND_TEMP
	rcall wait_10ms

	ldi temp, 0b00000001        ; DISPLAY lschen								
	rcall LCD_COMMAND_TEMP
	rcall wait_10ms

   	ldi temp, 0b00001111        ; DISPLAY ein / CURSOR blinken					
	rcall LCD_COMMAND_TEMP
	rcall wait_10ms

    ldi temp, 0b00000110        ; Cursor Auto-Increment							
	rcall LCD_COMMAND_TEMP
	rcall wait_10ms
; Text																			
	rcall LCD_CLEAR
	rcall ASCII_L
	rcall ASCII_C
	rcall ASCII_D
	rcall ASCII_SPACE
	rcall ASCII_o_
	rcall ASCII_k_
	rcall ZEILE3
	rcall ASCII_a_
	rcall ASCII_d_
	rcall ASCII_r_
	rcall ASCII_DOPPELPUNKT
	rcall ASCII_SPACE
	ldi temp1,(TWI_ADRESS_LCD)			; adresse	
	rcall ZAHL_TEMP1

	rjmp WAIT_1s
; ##############################################################################
; ##############################################################################
; ##############################################################################
LCD_DATA_TEMP:
	push temp1					; temp1 sichern			
	push temp					; temp sichern			
	push temp					; temp sichern			
	ldi temp1,(TWI_ADRESS_LCD)	; Adresse				
	rcall TWI_MT_START_TEMP1	; TWI-START				
; oberes Nibble											
	pop temp					; temp wieder herstellen
	clr temp1					; NULL					
	sbrc temp,7					; Sprung wenn Bit7=NULL	
	sbr temp1,BIT_D7			; Bit 7 setzen			
	sbrc temp,6					; Sprung wenn Bit6=NULL	
	sbr temp1,BIT_D6			; Bit 6 setzen			
	sbrc temp,5					; Sprung wenn Bit5=NULL	
	sbr temp1,BIT_D5			; Bit 5 setzen			
	sbrc temp,4					; Sprung wenn Bit4=NULL	
	sbr temp1,BIT_D4			; Bit 4 setzen			
	sbr temp1,BIT_RS			; RS (high) !!!			
	sbr temp1,BIT_EN			; EN (high)				
	sbr temp1,BIT_LED			; LED on(high)			
; Enable L-->H											
	rcall TWI_MT_DATA_TEMP1		; TWI TX-Data			
	cbr temp1,BIT_EN			; Enable L				
	rcall TWI_MT_DATA_TEMP1		; TWI TX-Data			
	sbr temp1,BIT_EN			; Enable H				
	rcall TWI_MT_DATA_TEMP1
; unteres Nibble										
	pop temp					; temp wieder herstellen
	clr temp1					; NULL					
	sbrc temp,3					; Sprung wenn Bit3=NULL	
	sbr temp1,BIT_D7			; Bit 7 setzen			
	sbrc temp,2					; Sprung wenn Bit2=NULL	
	sbr temp1,BIT_D6			; Bit 6 setzen			
	sbrc temp,1					; Sprung wenn Bit1=NULL	
	sbr temp1,BIT_D5			; Bit 5 setzen			
	sbrc temp,0					; Sprung wenn Bit0=NULL	
	sbr temp1,BIT_D4			; Bit 4 setzen			
	sbr temp1,BIT_RS			; RS (high) !!!			
	sbr temp1,BIT_EN			; EN (high)				
	sbr temp1,BIT_LED			; LED on(high)			
	rcall TWI_MT_DATA_TEMP1		; TWI TX-Data			
; Enable L-->H											
	rcall TWI_MT_DATA_TEMP1		; TWI TX-Data			
	cbr temp1,BIT_EN			; Enable L				
	rcall TWI_MT_DATA_TEMP1		; TWI TX-Data			
	sbr temp1,BIT_EN			; Enable H				
	rcall TWI_MT_DATA_TEMP1		; TWI TX-Data			
	pop temp1					; temp1 wieder herstellen
	ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
LCD_COMMAND_TEMP:
	push temp1					; temp1 sichern			
	push temp					; temp sichern			
	push temp					; temp sichern			
	ldi temp1,(TWI_ADRESS_LCD)	; Adresse				
	rcall TWI_MT_START_TEMP1	; TWI-START				
; oberes Nibble											
	pop temp					; temp wieder herstellen
	clr temp1					; NULL					
	sbrc temp,7					; Sprung wenn Bit7=NULL	
	sbr temp1,BIT_D7			; Bit 7 setzen			
	sbrc temp,6					; Sprung wenn Bit6=NULL	
	sbr temp1,BIT_D6			; Bit 6 setzen			
	sbrc temp,5					; Sprung wenn Bit5=NULL	
	sbr temp1,BIT_D5			; Bit 5 setzen			
	sbrc temp,4					; Sprung wenn Bit4=NULL	
	sbr temp1,BIT_D4			; Bit 4 setzen			
	cbr temp1,BIT_RS			; RS (low) !!!			
	sbr temp1,BIT_EN			; EN (high)				
	sbr temp1,BIT_LED			; LED on(high)			
; Enable L-->H											
	rcall TWI_MT_DATA_TEMP1		; TWI TX-Data			
	cbr temp1,BIT_EN			; Enable L				
	rcall TWI_MT_DATA_TEMP1		; TWI TX-Data			
	sbr temp1,BIT_EN			; Enable H				
	rcall TWI_MT_DATA_TEMP1
; unteres Nibble										
	pop temp					; temp wieder herstellen
	clr temp1					; NULL					
	sbrc temp,3					; Sprung wenn Bit3=NULL	
	sbr temp1,BIT_D7			; Bit 7 setzen			
	sbrc temp,2					; Sprung wenn Bit2=NULL	
	sbr temp1,BIT_D6			; Bit 6 setzen			
	sbrc temp,1					; Sprung wenn Bit1=NULL	
	sbr temp1,BIT_D5			; Bit 5 setzen			
	sbrc temp,0					; Sprung wenn Bit0=NULL	
	sbr temp1,BIT_D4			; Bit 4 setzen			
	cbr temp1,BIT_RS			; RS (low) !!!			
	sbr temp1,BIT_EN			; EN (high)				
	sbr temp1,BIT_LED			; LED on(high)			
	rcall TWI_MT_DATA_TEMP1		; TWI TX-Data			
; Enable L-->H											
	rcall TWI_MT_DATA_TEMP1		; TWI TX-Data			
	cbr temp1,BIT_EN			; Enable L				
	rcall TWI_MT_DATA_TEMP1		; TWI TX-Data			
	sbr temp1,BIT_EN			; Enable H				
	rcall TWI_MT_DATA_TEMP1		; TWI TX-Data			
	rcall WAIT_1ms				; Pause					
	pop temp1					; temp1 wieder herstellen
ret
;#######################################################################
;#######################################################################
;#######################################################################
ANZEIGE_TEXT:
	LPM temp, Z+   			; aus Tabelle laden und Zeiger um 1 erhhen	
	tst temp  			
	breq ANZEIGE_TEXT_e 	; Sprung	
	rcall LCD_DATA_temp		; Anzeige	
	rjmp ANZEIGE_TEXT
ANZEIGE_TEXT_e:
ret
;###############################################################################
;###############################################################################
;###############################################################################
; LCD-Hintergrundbeleuchtung													
LCD_LIGHT_ON:
	ldi temp1,(1<<LCD_RS)|(0<<LCD_RW)|(1<<LCD_EN)|(1<<LCD_LED)|(1<<LCD_D4)|(1<<LCD_D5)|(1<<LCD_D6)|(1<<LCD_D7)	; Data        				
	rjmp TWI_MT_DATA_TEMP1	
;###############################################################################
;###############################################################################
;###############################################################################
; LCD-Hintergrundbeleuchtung													
LCD_LIGHT_OFF:
	ldi temp1,(1<<LCD_RS)|(0<<LCD_RW)|(1<<LCD_EN)|(0<<LCD_LED)|(1<<LCD_D4)|(1<<LCD_D5)|(1<<LCD_D6)|(1<<LCD_D7)	; Data        				
	rjmp TWI_MT_DATA_TEMP1	
;###############################################################################
;###############################################################################
;###############################################################################
LCD_CLEAR:
	ldi temp, 0b00000001
	rjmp LCD_COMMAND_TEMP
;###############################################################################
;###############################################################################
;###############################################################################
ZEILE0:
 	ldi temp, 0b00000010
	rjmp LCD_COMMAND_TEMP
;###############################################################################
;###############################################################################
;###############################################################################
ZEILE1:
 	ldi temp, 0b11000000 
	rjmp LCD_COMMAND_TEMP 
;###############################################################################
;###############################################################################
;###############################################################################
ZEILE2:
 	ldi temp, 0b10010100  	; LCD 4x20
	rjmp LCD_COMMAND_TEMP 
;###############################################################################
;###############################################################################
;###############################################################################
ZEILE3:
	ldi temp, 0b11010100	; LCD 4x20
	rjmp LCD_COMMAND_TEMP 
;###############################################################################
;###############################################################################
;###############################################################################
