;												
; ATmega8 + TWI LCD	PCF8574						
; 4 Bit-Modus									
; 07/2024										
;												

;												
; Bei Programmstart LED ROT, GELB und GRN Test	
;												
; Nun Fragt der Master den Slave ab.			
; Error blinkt: ROT+GELB						
;												

; PCF8574										
;-nach anlegen der Betriebsspannung alle PINS H	
;												

;												
; ROT blinkt: 			Programm Check Error	
; ROT+GELB+GRN blinkt: Interrupt Error			
;												

; ATmega8 										
.include "m8def.inc"
.include "MACRO.asm"
; TWI-Adressen									
.equ TWI_ADRESS_LCD					= 39	; Adresse		

.equ LCD_RS							= 0
.equ LCD_RW							= 1		; Standard L	
.equ LCD_EN							= 2
.equ LCD_LED						= 3		; L=off	H=ON	
.equ LCD_D4							= 4
.equ LCD_D5							= 5
.equ LCD_D6							= 6
.equ LCD_D7							= 7

.equ BIT_RS							= 1
.equ BIT_RW							= 2
.equ BIT_EN							= 4
.equ BIT_LED						= 8
.equ BIT_D4							= 16
.equ BIT_D5							= 32
.equ BIT_D6							= 64
.equ BIT_D7							= 128
; LED-GRUEN										
.equ GRUEN_PIN_NR					= 3
.equ GRUEN_DDR						= DDRB
.equ GRUEN_PORT						= PORTB
; LED-GELB										
.equ GELB_PIN_NR					= 4
.equ GELB_DDR						= DDRB
.equ GELB_PORT						= PORTB
; LED-ROT										
.equ ROT_PIN_NR						= 5
.equ ROT_DDR						= DDRB
.equ ROT_PORT						= PORTB

; SRAM											
.equ adr_DATEN						=SRAM_START		; 0x0060 START Adresse 		

.equ adr_BYTE0						=SRAM_START+10
.equ adr_BYTE1						=SRAM_START+11
.equ adr_BYTE2						=SRAM_START+12
.equ adr_BYTE3						=SRAM_START+13

.equ adr_SRAM_CHECK					=SRAM_START+943	; SRAM CHECK muss immer "S" sein	

; REGISTER										

.def ERROR	= R10

.def NULL 	= R12
.def EINS 	= R14
.def VOLL	= R15

.def temp 	= R16
.def temp1 	= R17
.def temp2 	= R18
.def temp3 	= R19
.def temp4 	= R20
.def temp5 	= R21
.def temp6 	= R22
.def temp7 	= R23
.def temp8 	= R24
.def temp9 	= R25


.cseg					;Beginn eines Code-Segmentes
.org 0					;Startadresse=0

rjmp RESET      		; Reset Handler                           				
rjmp INTERRUPT_ERROR	;rjmp EXT_INT0   ; IRQ0 Handler                      	
rjmp INTERRUPT_ERROR	;rjmp EXT_INT1   ; IRQ1 Handler                      	
rjmp INTERRUPT_ERROR	;rjmp TIM2_COMP  ; Timer2 Compare Handler            	
rjmp INTERRUPT_ERROR	;rjmp TIM2_OVF   ; Timer2 Overflow Handler           	
rjmp INTERRUPT_ERROR	;rjmp TIM1_CAPT  ; Timer1 Capture Handler            	
rjmp INTERRUPT_ERROR	;rjmp TIM1_COMPA ; Timer1 CompareA Handler           	
rjmp INTERRUPT_ERROR	;rjmp TIM1_COMPB ; Timer1 CompareB Handler           	
rjmp INTERRUPT_ERROR	; Timer1 Overflow Handler           					
rjmp INTERRUPT_ERROR	; Timer0 Overflow Handler           					
rjmp INTERRUPT_ERROR	;rjmp SPI_STC    ; SPI Transfer Complete Handler     	
rjmp INTERRUPT_ERROR	;rjmp ZEICHEN_EINLESEN 	; USART RX Complete Handler     
rjmp INTERRUPT_ERROR	;rjmp USART_UDRE ; UDR Empty Handler                 	
rjmp INTERRUPT_ERROR	;rjmp USART_TXC  ; USART TX Complete Handler         	
rjmp INTERRUPT_ERROR	;rjmp ADC        ; ADC Conversion Complete Handler   	
rjmp INTERRUPT_ERROR	;rjmp EE_RDY     ; EEPROM Ready Handler              	
rjmp INTERRUPT_ERROR	;rjmp ANA_COMP   ; Analog Comparator Handler         	
rjmp INTERRUPT_ERROR	;rjmp TWSI       ; Two-wire Serial Interface Handler 	
rjmp INTERRUPT_ERROR	;rjmp SPM_RDY    ; Store Program Memory Ready Handler	
;-------------------------------------------------------------------------------
; Unkorrekten Interrupt Aufruf, schnelles blinken								
INTERRUPT_ERROR:
	GRUEN_ON
	GELB_ON
	ROT_ON
	rcall wait_20ms
	GRUEN_OFF
	GELB_OFF
	ROT_OFF
	rcall wait_20ms
	rjmp INTERRUPT_ERROR
;-------------------------------------------------------------------------------
RESET:                        
	ldi temp, LOW(RAMEND)					; STACK initialisieren				
    out SPL, temp
    ldi temp, HIGH(RAMEND)
    out SPH, temp

	rcall WDR_INITIALISIERUNG				; WDR_INITIALISIERUNG				
	rcall SRAM_CLEAR						; SRAM lschen						
	rcall STARTWERTE						; Startwerte						
	rcall PORT_INI							; PORT_CLEAR						
;rcall PROGRAMM_STOP
	rcall TWI_INI							; TWI								
	rcall LCD_TWI_TEST
	rcall PROGRAMM_CHECK					; CHECK								
	rcall LCD_INI
	rcall ANZEIGE_BEGRUESSUNG
	rcall WAIT_1s
	sei										; Interrupts freigeben				
	rcall LCD_LIGHT_OFF						; Hintergrundbeleuchtung OFF		
	rcall WAIT_20ms
	rcall LCD_LIGHT_ON						; Hintergrundbeleuchtung ON			
	rcall WAIT_100ms
	rcall LCD_CLEAR
	GRUEN_ON								; LED								
;-------------------------------------------------------------------------------
LOOP:
	rcall ZEILE0
	rcall ASCII_SPACE7
	LDS temp1,(adr_BYTE0)
	rcall ZAHL_TEMP1
	rcall ASCII_SPACE6
	rcall ASCII_x_
	LDS temp1,(adr_BYTE0)
	rcall HEX_TEMP1

	rcall ZEILE1
	rcall ASCII_SPACE5
	LDS temp1,(adr_BYTE0)
	LDS temp2,(adr_BYTE1)
	rcall ZAHL_TEMP1_2
	rcall ASCII_SPACE4
	rcall ASCII_x_
	LDS temp1,(adr_BYTE1)
	rcall HEX_TEMP1
	LDS temp1,(adr_BYTE0)
	rcall HEX_TEMP1


	rcall ZEILE2
	rcall ASCII_SPACE2
	LDS temp1,(adr_BYTE0)
	LDS temp2,(adr_BYTE1)
	LDS temp3,(adr_BYTE2)
	rcall ZAHL_TEMP1_2_3
	rcall ASCII_SPACE2
	rcall ASCII_x_
	LDS temp1,(adr_BYTE2)
	rcall HEX_TEMP1
	LDS temp1,(adr_BYTE1)
	rcall HEX_TEMP1
	LDS temp1,(adr_BYTE0)
	rcall HEX_TEMP1

	rcall ZEILE3
	LDS temp1,(adr_BYTE0)
	LDS temp2,(adr_BYTE1)
	LDS temp3,(adr_BYTE2)
	LDS temp4,(adr_BYTE3)
	rcall ZAHL_TEMP1_2_3_4
	rcall ASCII_x_
	LDS temp1,(adr_BYTE3)
	rcall HEX_TEMP1
	LDS temp1,(adr_BYTE2)
	rcall HEX_TEMP1
	LDS temp1,(adr_BYTE1)
	rcall HEX_TEMP1
	LDS temp1,(adr_BYTE0)
	rcall HEX_TEMP1

	; Testzahl +1			
	LDS temp1,(adr_BYTE0)
	LDS temp2,(adr_BYTE1)
	LDS temp3,(adr_BYTE2)
	LDS temp4,(adr_BYTE3)
	add temp1,EINS
	adc temp2,NULL
	adc temp3,NULL
	adc temp4,NULL
	STS(adr_BYTE0),temp1
	STS(adr_BYTE1),temp2
	STS(adr_BYTE2),temp3
	STS(adr_BYTE3),temp4

rjmp LOOP
; ##############################################################################
; ##############################################################################
; ##############################################################################
.include "TWI.asm"
.include "TWI_LCD.asm"
.include "ANZEIGE.asm"
.include "ASCII.asm"
.include "ZAHLEN.asm"
.include "SONSTIGES.asm"
.include "WAIT.asm"
;-------------------------------------------------------------------------------
TEXT_BEGRUESSUNG_1:
.db "Moin ",0
TEXT_BEGRUESSUNG_2:
.db "ATmega8 Freak",0
TEXT_BEGRUESSUNG_3:
.db "schoenen Gruss aus ",0
TEXT_BEGRUESSUNG_4:
.db "Erfurt 07/2024 V1",0
